#include "readline.h"

static int enlarge( int oldSize ) {
    if ( oldSize < 1024 )
        return 2 * oldSize;
    else
        return oldSize + 1024;
}

char *readLine() {
    size_t end = 0;
    size_t capacity = 16;
    char *line = (char*) malloc( capacity );
    int c;

    if ( !line )// allocation has failed
        return NULL;

    while( '\n' != ( c = getc( stdin ) ) && c != EOF ) {
        line[ end++ ] = c;
        if ( end == capacity ) {
            capacity = enlarge( capacity );
            char *tmp = (char*) realloc( line, capacity );
            if ( !tmp ) {
                free( line );
                return NULL;// allocation has failed
            }
            line = tmp;
        }
    }
    line[ end ] = '\0';
    return line;
}

